package com.mortals.xhx.module.site.web;

import com.mortals.framework.exception.AppException;
import com.mortals.framework.model.Context;
import com.mortals.framework.web.BaseCRUDJsonBodyMappingController;
import com.mortals.framework.web.BasePhpCRUDJsonMappingController;
import com.mortals.xhx.base.system.param.service.ParamService;
import com.mortals.xhx.module.site.model.SiteMatterEntity;
import com.mortals.xhx.module.site.service.SiteMatterService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.ObjectUtils;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.ArrayList;
import java.util.Map;

/**
 * 站点事项
 *
 * @author zxfei
 * @date 2022-01-20
 */
@RestController
@RequestMapping("site/matter")
public class SiteMatterController extends BaseCRUDJsonBodyMappingController<SiteMatterService, SiteMatterEntity, Long> {

    @Autowired
    private ParamService paramService;

    public SiteMatterController() {
        super.setFormClass(SiteMatterForm.class);
        super.setModuleDesc("站点事项");
    }

    /**
     * @param query
     * @param model
     * @param context
     * @throws AppException
     */
    @Override
    protected void doListBefore(SiteMatterEntity query, Map<String, Object> model, Context context) throws AppException {
        super.doListBefore(query, model, context);
        if(ObjectUtils.isEmpty(query.getEventTypeShowNotList())){
            ArrayList<String> notList = new ArrayList<>();
            notList.add("行政处罚");
            query.setEventTypeShowNotList(notList);
        }
    }
}